<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd"><html xmlns="http://www.w3.org/1999/xhtml"><head><link rel="stylesheet" type="text/css" href="style.css" /><script type="text/javascript" src="highlight.js"></script></head><body><pre><span class="hs-keyword">module</span><span> </span><span class="hs-identifier">SDL.GPU.Simple.ContextControls</span><span> </span><span class="hs-keyword">where</span><span>
</span><span id="line-2"></span><span>
</span><span id="line-3"></span><span class="hs-keyword">import</span><span> </span><span class="annot"><span class="hs-identifier">Prelude</span></span><span>
</span><span id="line-4"></span><span class="hs-keyword">import</span><span> </span><span class="annot"><span class="hs-identifier">Data.Word</span></span><span>
</span><span id="line-5"></span><span class="hs-keyword">import</span><span> </span><span class="annot"><span class="hs-identifier">Foreign.Ptr</span></span><span>
</span><span id="line-6"></span><span class="hs-keyword">import</span><span> </span><span class="annot"><a href="SDL.GPU.C.html"><span class="hs-identifier">SDL.GPU.C</span></a></span><span> </span><span class="hs-keyword">as</span><span> </span><span class="annot"><span class="hs-identifier">GPU</span></span><span>
</span><span id="line-7"></span><span class="hs-keyword">import</span><span> </span><span class="annot"><span class="hs-identifier">Control.Monad.IO.Class</span></span><span>
</span><span id="line-8"></span><span class="hs-keyword">import</span><span> </span><span class="annot"><a href="Memorable.html"><span class="hs-identifier">Memorable</span></a></span><span>
</span><span id="line-9"></span><span class="hs-keyword">import</span><span> </span><span class="annot"><span class="hs-identifier">Foreign.Storable</span></span><span>
</span><span id="line-10"></span><span class="hs-keyword">import</span><span> </span><span class="annot"><span class="hs-identifier">Foreign.Marshal.Alloc</span></span><span>
</span><span id="line-11"></span><span>
</span><span id="line-12"></span><span class="annot"><a href="SDL.GPU.Simple.ContextControls.html#getContextTarget"><span class="hs-identifier hs-type">getContextTarget</span></a></span><span> </span><span class="hs-glyph">::</span><span> </span><span class="hs-keyword">forall</span><span> </span><span id="local-6989586621679189949"><span class="annot"><a href="#local-6989586621679189949"><span class="hs-identifier hs-type">m</span></a></span></span><span class="hs-operator">.</span><span> </span><span class="annot"><span class="hs-identifier hs-type">MonadIO</span></span><span> </span><span class="annot"><a href="#local-6989586621679189949"><span class="hs-identifier hs-type">m</span></a></span><span> </span><span class="hs-glyph">=&gt;</span><span> </span><span class="annot"><a href="#local-6989586621679189949"><span class="hs-identifier hs-type">m</span></a></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="hs-identifier hs-type">Ptr</span></span><span> </span><span class="annot"><a href="SDL.GPU.C.Types.html#Target"><span class="hs-identifier hs-type">GPU.Target</span></a></span><span class="hs-special">)</span><span>
</span><span id="line-13"></span><span id="getContextTarget"><span class="annot"><span class="annottext">getContextTarget :: forall (m :: * -&gt; *). MonadIO m =&gt; m (Ptr Target)
</span><a href="SDL.GPU.Simple.ContextControls.html#getContextTarget"><span class="hs-identifier hs-var hs-var">getContextTarget</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">forall (m :: * -&gt; *) a. MonadIO m =&gt; IO a -&gt; m a
</span><span class="hs-identifier hs-var">liftIO</span></span><span> </span><span class="annot"><span class="annottext">IO (Ptr Target)
</span><a href="SDL.GPU.C.ContextControls.html#getContextTarget"><span class="hs-identifier hs-var">GPU.getContextTarget</span></a></span><span>
</span><span id="line-14"></span><span>
</span><span id="line-15"></span><span class="hs-comment">-- TODO: newtype WindowID</span><span>
</span><span id="line-16"></span><span class="annot"><a href="SDL.GPU.Simple.ContextControls.html#getWindowTarget"><span class="hs-identifier hs-type">getWindowTarget</span></a></span><span> </span><span class="hs-glyph">::</span><span> </span><span class="hs-keyword">forall</span><span> </span><span id="local-6989586621679189943"><span class="annot"><a href="#local-6989586621679189943"><span class="hs-identifier hs-type">m</span></a></span></span><span class="hs-operator">.</span><span> </span><span class="annot"><span class="hs-identifier hs-type">MonadIO</span></span><span> </span><span class="annot"><a href="#local-6989586621679189943"><span class="hs-identifier hs-type">m</span></a></span><span> </span><span class="hs-glyph">=&gt;</span><span> </span><span class="annot"><a href="SDL.GPU.C.NumericTypes.html#Uint32"><span class="hs-identifier hs-type">GPU.Uint32</span></a></span><span> </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="#local-6989586621679189943"><span class="hs-identifier hs-type">m</span></a></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="hs-identifier hs-type">Ptr</span></span><span> </span><span class="annot"><a href="SDL.GPU.C.Types.html#Target"><span class="hs-identifier hs-type">GPU.Target</span></a></span><span class="hs-special">)</span><span>
</span><span id="line-17"></span><span id="getWindowTarget"><span class="annot"><span class="annottext">getWindowTarget :: forall (m :: * -&gt; *). MonadIO m =&gt; Uint32 -&gt; m (Ptr Target)
</span><a href="SDL.GPU.Simple.ContextControls.html#getWindowTarget"><span class="hs-identifier hs-var hs-var">getWindowTarget</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">forall (m :: * -&gt; *) a. MonadIO m =&gt; IO a -&gt; m a
</span><span class="hs-identifier hs-var">liftIO</span></span><span> </span><span class="annot"><span class="annottext">forall b c a. (b -&gt; c) -&gt; (a -&gt; b) -&gt; a -&gt; c
</span><span class="hs-operator hs-var">.</span></span><span> </span><span class="annot"><span class="annottext">Uint32 -&gt; IO (Ptr Target)
</span><a href="SDL.GPU.C.ContextControls.html#getWindowTarget"><span class="hs-identifier hs-var">GPU.getWindowTarget</span></a></span><span>
</span><span id="line-18"></span><span>
</span><span id="line-19"></span><span class="annot"><a href="SDL.GPU.Simple.ContextControls.html#createTargetFromWindow"><span class="hs-identifier hs-type">createTargetFromWindow</span></a></span><span> </span><span class="hs-glyph">::</span><span> </span><span class="hs-keyword">forall</span><span> </span><span id="local-6989586621679189875"><span class="annot"><a href="#local-6989586621679189875"><span class="hs-identifier hs-type">m</span></a></span></span><span class="hs-operator">.</span><span> </span><span class="annot"><span class="hs-identifier hs-type">MonadIO</span></span><span> </span><span class="annot"><a href="#local-6989586621679189875"><span class="hs-identifier hs-type">m</span></a></span><span> </span><span class="hs-glyph">=&gt;</span><span> </span><span class="annot"><a href="SDL.GPU.C.NumericTypes.html#Uint32"><span class="hs-identifier hs-type">GPU.Uint32</span></a></span><span> </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="#local-6989586621679189875"><span class="hs-identifier hs-type">m</span></a></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="hs-identifier hs-type">Ptr</span></span><span> </span><span class="annot"><a href="SDL.GPU.C.Types.html#Target"><span class="hs-identifier hs-type">GPU.Target</span></a></span><span class="hs-special">)</span><span>
</span><span id="line-20"></span><span id="createTargetFromWindow"><span class="annot"><span class="annottext">createTargetFromWindow :: forall (m :: * -&gt; *). MonadIO m =&gt; Uint32 -&gt; m (Ptr Target)
</span><a href="SDL.GPU.Simple.ContextControls.html#createTargetFromWindow"><span class="hs-identifier hs-var hs-var">createTargetFromWindow</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">forall (m :: * -&gt; *) a. MonadIO m =&gt; IO a -&gt; m a
</span><span class="hs-identifier hs-var">liftIO</span></span><span> </span><span class="annot"><span class="annottext">forall b c a. (b -&gt; c) -&gt; (a -&gt; b) -&gt; a -&gt; c
</span><span class="hs-operator hs-var">.</span></span><span> </span><span class="annot"><span class="annottext">Uint32 -&gt; IO (Ptr Target)
</span><a href="SDL.GPU.C.ContextControls.html#createTargetFromWindow"><span class="hs-identifier hs-var">GPU.createTargetFromWindow</span></a></span><span>
</span><span id="line-21"></span><span>
</span><span id="line-22"></span><span class="annot"><a href="SDL.GPU.Simple.ContextControls.html#makeCurrent"><span class="hs-identifier hs-type">makeCurrent</span></a></span><span> </span><span class="hs-glyph">::</span><span> </span><span class="hs-keyword">forall</span><span> </span><span id="local-6989586621679189936"><span class="annot"><a href="#local-6989586621679189936"><span class="hs-identifier hs-type">m</span></a></span></span><span class="hs-operator">.</span><span> </span><span class="annot"><span class="hs-identifier hs-type">MonadIO</span></span><span> </span><span class="annot"><a href="#local-6989586621679189936"><span class="hs-identifier hs-type">m</span></a></span><span> </span><span class="hs-glyph">=&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Ptr</span></span><span> </span><span class="annot"><a href="SDL.GPU.C.Types.html#Target"><span class="hs-identifier hs-type">GPU.Target</span></a></span><span> </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="SDL.GPU.C.NumericTypes.html#Uint32"><span class="hs-identifier hs-type">GPU.Uint32</span></a></span><span> </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="#local-6989586621679189936"><span class="hs-identifier hs-type">m</span></a></span><span> </span><span class="hs-special">(</span><span class="hs-special">)</span><span>
</span><span id="line-23"></span><span id="makeCurrent"><span class="annot"><span class="annottext">makeCurrent :: forall (m :: * -&gt; *). MonadIO m =&gt; Ptr Target -&gt; Uint32 -&gt; m ()
</span><a href="SDL.GPU.Simple.ContextControls.html#makeCurrent"><span class="hs-identifier hs-var hs-var">makeCurrent</span></a></span></span><span> </span><span id="local-6989586621679189868"><span class="annot"><span class="annottext">Ptr Target
</span><a href="#local-6989586621679189868"><span class="hs-identifier hs-var">t</span></a></span></span><span> </span><span id="local-6989586621679189867"><span class="annot"><span class="annottext">Uint32
</span><a href="#local-6989586621679189867"><span class="hs-identifier hs-var">w</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">forall (m :: * -&gt; *) a. MonadIO m =&gt; IO a -&gt; m a
</span><span class="hs-identifier hs-var">liftIO</span></span><span> </span><span class="annot"><span class="annottext">forall a b. (a -&gt; b) -&gt; a -&gt; b
</span><span class="hs-operator hs-var">$</span></span><span> </span><span class="annot"><span class="annottext">Ptr Target -&gt; Uint32 -&gt; IO ()
</span><a href="SDL.GPU.C.ContextControls.html#makeCurrent"><span class="hs-identifier hs-var">GPU.makeCurrent</span></a></span><span> </span><span class="annot"><span class="annottext">Ptr Target
</span><a href="#local-6989586621679189868"><span class="hs-identifier hs-var">t</span></a></span><span> </span><span class="annot"><span class="annottext">Uint32
</span><a href="#local-6989586621679189867"><span class="hs-identifier hs-var">w</span></a></span><span>
</span><span id="line-24"></span><span>
</span><span id="line-25"></span><span class="annot"><a href="SDL.GPU.Simple.ContextControls.html#setWindowResolution"><span class="hs-identifier hs-type">setWindowResolution</span></a></span><span>
</span><span id="line-26"></span><span>  </span><span class="hs-glyph">::</span><span> </span><span class="hs-keyword">forall</span><span> </span><span id="local-6989586621679189931"><span class="annot"><a href="#local-6989586621679189931"><span class="hs-identifier hs-type">m</span></a></span></span><span>
</span><span id="line-27"></span><span>   </span><span class="hs-operator">.</span><span> </span><span class="annot"><span class="hs-identifier hs-type">MonadIO</span></span><span> </span><span class="annot"><a href="#local-6989586621679189931"><span class="hs-identifier hs-type">m</span></a></span><span>
</span><span id="line-28"></span><span>  </span><span class="hs-glyph">=&gt;</span><span> </span><span class="annot"><a href="SDL.GPU.C.NumericTypes.html#Uint16"><span class="hs-identifier hs-type">GPU.Uint16</span></a></span><span> </span><span class="hs-comment">-- ^ w</span><span>
</span><span id="line-29"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="SDL.GPU.C.NumericTypes.html#Uint16"><span class="hs-identifier hs-type">GPU.Uint16</span></a></span><span> </span><span class="hs-comment">-- ^ h</span><span>
</span><span id="line-30"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="#local-6989586621679189931"><span class="hs-identifier hs-type">m</span></a></span><span> </span><span class="annot"><span class="hs-identifier hs-type">Prelude.Bool</span></span><span>
</span><span id="line-31"></span><span id="setWindowResolution"><span class="annot"><span class="annottext">setWindowResolution :: forall (m :: * -&gt; *). MonadIO m =&gt; Uint16 -&gt; Uint16 -&gt; m Bool
</span><a href="SDL.GPU.Simple.ContextControls.html#setWindowResolution"><span class="hs-identifier hs-var hs-var">setWindowResolution</span></a></span></span><span> </span><span id="local-6989586621679189855"><span class="annot"><span class="annottext">Uint16
</span><a href="#local-6989586621679189855"><span class="hs-identifier hs-var">w</span></a></span></span><span> </span><span id="local-6989586621679189854"><span class="annot"><span class="annottext">Uint16
</span><a href="#local-6989586621679189854"><span class="hs-identifier hs-var">h</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">forall (f :: * -&gt; *) a b. Functor f =&gt; (a -&gt; b) -&gt; f a -&gt; f b
</span><span class="hs-identifier hs-var">fmap</span></span><span> </span><span class="annot"><span class="annottext">Bool -&gt; Bool
</span><a href="SDL.GPU.C.Bool.html#isTrue"><span class="hs-identifier hs-var">GPU.isTrue</span></a></span><span> </span><span class="annot"><span class="annottext">forall a b. (a -&gt; b) -&gt; a -&gt; b
</span><span class="hs-operator hs-var">$</span></span><span> </span><span class="annot"><span class="annottext">forall (m :: * -&gt; *) a. MonadIO m =&gt; IO a -&gt; m a
</span><span class="hs-identifier hs-var">liftIO</span></span><span> </span><span class="annot"><span class="annottext">forall a b. (a -&gt; b) -&gt; a -&gt; b
</span><span class="hs-operator hs-var">$</span></span><span> </span><span class="annot"><span class="annottext">Uint16 -&gt; Uint16 -&gt; IO Bool
</span><a href="SDL.GPU.C.ContextControls.html#setWindowResolution"><span class="hs-identifier hs-var">GPU.setWindowResolution</span></a></span><span> </span><span class="annot"><span class="annottext">Uint16
</span><a href="#local-6989586621679189855"><span class="hs-identifier hs-var">w</span></a></span><span> </span><span class="annot"><span class="annottext">Uint16
</span><a href="#local-6989586621679189854"><span class="hs-identifier hs-var">h</span></a></span><span>
</span><span id="line-32"></span><span>
</span><span id="line-33"></span><span class="annot"><a href="SDL.GPU.Simple.ContextControls.html#getFullscreen"><span class="hs-identifier hs-type">getFullscreen</span></a></span><span>
</span><span id="line-34"></span><span>  </span><span class="hs-glyph">::</span><span> </span><span class="hs-keyword">forall</span><span> </span><span id="local-6989586621679189922"><span class="annot"><a href="#local-6989586621679189922"><span class="hs-identifier hs-type">m</span></a></span></span><span>
</span><span id="line-35"></span><span>   </span><span class="hs-operator">.</span><span> </span><span class="annot"><span class="hs-identifier hs-type">MonadIO</span></span><span> </span><span class="annot"><a href="#local-6989586621679189922"><span class="hs-identifier hs-type">m</span></a></span><span>
</span><span id="line-36"></span><span>  </span><span class="hs-glyph">=&gt;</span><span> </span><span class="annot"><a href="#local-6989586621679189922"><span class="hs-identifier hs-type">m</span></a></span><span> </span><span class="annot"><span class="hs-identifier hs-type">Prelude.Bool</span></span><span>
</span><span id="line-37"></span><span id="getFullscreen"><span class="annot"><span class="annottext">getFullscreen :: forall (m :: * -&gt; *). MonadIO m =&gt; m Bool
</span><a href="SDL.GPU.Simple.ContextControls.html#getFullscreen"><span class="hs-identifier hs-var hs-var">getFullscreen</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">forall (f :: * -&gt; *) a b. Functor f =&gt; (a -&gt; b) -&gt; f a -&gt; f b
</span><span class="hs-identifier hs-var">fmap</span></span><span> </span><span class="annot"><span class="annottext">Bool -&gt; Bool
</span><a href="SDL.GPU.C.Bool.html#isTrue"><span class="hs-identifier hs-var">GPU.isTrue</span></a></span><span> </span><span class="annot"><span class="annottext">forall a b. (a -&gt; b) -&gt; a -&gt; b
</span><span class="hs-operator hs-var">$</span></span><span> </span><span class="annot"><span class="annottext">forall (m :: * -&gt; *) a. MonadIO m =&gt; IO a -&gt; m a
</span><span class="hs-identifier hs-var">liftIO</span></span><span> </span><span class="annot"><span class="annottext">forall a b. (a -&gt; b) -&gt; a -&gt; b
</span><span class="hs-operator hs-var">$</span></span><span> </span><span class="annot"><span class="annottext">IO Bool
</span><a href="SDL.GPU.C.ContextControls.html#getFullscreen"><span class="hs-identifier hs-var">GPU.getFullscreen</span></a></span><span>
</span><span id="line-38"></span><span>
</span><span id="line-39"></span><span class="annot"><a href="SDL.GPU.Simple.ContextControls.html#setFullscreen"><span class="hs-identifier hs-type">setFullscreen</span></a></span><span>
</span><span id="line-40"></span><span>  </span><span class="hs-glyph">::</span><span> </span><span class="hs-keyword">forall</span><span> </span><span id="local-6989586621679189920"><span class="annot"><a href="#local-6989586621679189920"><span class="hs-identifier hs-type">m</span></a></span></span><span>
</span><span id="line-41"></span><span>   </span><span class="hs-operator">.</span><span> </span><span class="annot"><span class="hs-identifier hs-type">MonadIO</span></span><span> </span><span class="annot"><a href="#local-6989586621679189920"><span class="hs-identifier hs-type">m</span></a></span><span>
</span><span id="line-42"></span><span>  </span><span class="hs-glyph">=&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Prelude.Bool</span></span><span> </span><span class="hs-comment">-- ^ enable_fullscreen</span><span>
</span><span id="line-43"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Prelude.Bool</span></span><span> </span><span class="hs-comment">-- ^ use_desktop_resolution</span><span>
</span><span id="line-44"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="#local-6989586621679189920"><span class="hs-identifier hs-type">m</span></a></span><span> </span><span class="annot"><span class="hs-identifier hs-type">Prelude.Bool</span></span><span>
</span><span id="line-45"></span><span id="setFullscreen"><span class="annot"><span class="annottext">setFullscreen :: forall (m :: * -&gt; *). MonadIO m =&gt; Bool -&gt; Bool -&gt; m Bool
</span><a href="SDL.GPU.Simple.ContextControls.html#setFullscreen"><span class="hs-identifier hs-var hs-var">setFullscreen</span></a></span></span><span> </span><span id="local-6989586621679189836"><span class="annot"><span class="annottext">Bool
</span><a href="#local-6989586621679189836"><span class="hs-identifier hs-var">ef</span></a></span></span><span> </span><span id="local-6989586621679189835"><span class="annot"><span class="annottext">Bool
</span><a href="#local-6989586621679189835"><span class="hs-identifier hs-var">udr</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">forall (f :: * -&gt; *) a b. Functor f =&gt; (a -&gt; b) -&gt; f a -&gt; f b
</span><span class="hs-identifier hs-var">fmap</span></span><span> </span><span class="annot"><span class="annottext">Bool -&gt; Bool
</span><a href="SDL.GPU.C.Bool.html#isTrue"><span class="hs-identifier hs-var">GPU.isTrue</span></a></span><span> </span><span class="annot"><span class="annottext">forall a b. (a -&gt; b) -&gt; a -&gt; b
</span><span class="hs-operator hs-var">$</span></span><span> </span><span class="annot"><span class="annottext">forall (m :: * -&gt; *) a. MonadIO m =&gt; IO a -&gt; m a
</span><span class="hs-identifier hs-var">liftIO</span></span><span> </span><span class="annot"><span class="annottext">forall a b. (a -&gt; b) -&gt; a -&gt; b
</span><span class="hs-operator hs-var">$</span></span><span> </span><span class="annot"><span class="annottext">Bool -&gt; Bool -&gt; IO Bool
</span><a href="SDL.GPU.C.ContextControls.html#setFullscreen"><span class="hs-identifier hs-var">GPU.setFullscreen</span></a></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="annottext">Bool -&gt; Bool
</span><a href="SDL.GPU.C.Bool.html#bool"><span class="hs-identifier hs-var">GPU.bool</span></a></span><span> </span><span class="annot"><span class="annottext">Bool
</span><a href="#local-6989586621679189836"><span class="hs-identifier hs-var">ef</span></a></span><span class="hs-special">)</span><span> </span><span class="hs-special">(</span><span class="annot"><span class="annottext">Bool -&gt; Bool
</span><a href="SDL.GPU.C.Bool.html#bool"><span class="hs-identifier hs-var">GPU.bool</span></a></span><span> </span><span class="annot"><span class="annottext">Bool
</span><a href="#local-6989586621679189835"><span class="hs-identifier hs-var">udr</span></a></span><span class="hs-special">)</span><span>
</span><span id="line-46"></span><span>
</span><span id="line-47"></span><span class="annot"><a href="SDL.GPU.Simple.ContextControls.html#getActiveTarget"><span class="hs-identifier hs-type">getActiveTarget</span></a></span><span> </span><span class="hs-glyph">::</span><span> </span><span class="hs-keyword">forall</span><span> </span><span id="local-6989586621679189831"><span class="annot"><a href="#local-6989586621679189831"><span class="hs-identifier hs-type">m</span></a></span></span><span class="hs-operator">.</span><span> </span><span class="annot"><span class="hs-identifier hs-type">MonadIO</span></span><span> </span><span class="annot"><a href="#local-6989586621679189831"><span class="hs-identifier hs-type">m</span></a></span><span> </span><span class="hs-glyph">=&gt;</span><span> </span><span class="annot"><a href="#local-6989586621679189831"><span class="hs-identifier hs-type">m</span></a></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="hs-identifier hs-type">Ptr</span></span><span> </span><span class="annot"><a href="SDL.GPU.C.Types.html#Target"><span class="hs-identifier hs-type">GPU.Target</span></a></span><span class="hs-special">)</span><span>
</span><span id="line-48"></span><span id="getActiveTarget"><span class="annot"><span class="annottext">getActiveTarget :: forall (m :: * -&gt; *). MonadIO m =&gt; m (Ptr Target)
</span><a href="SDL.GPU.Simple.ContextControls.html#getActiveTarget"><span class="hs-identifier hs-var hs-var">getActiveTarget</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">forall (m :: * -&gt; *) a. MonadIO m =&gt; IO a -&gt; m a
</span><span class="hs-identifier hs-var">liftIO</span></span><span> </span><span class="annot"><span class="annottext">IO (Ptr Target)
</span><a href="SDL.GPU.C.ContextControls.html#getActiveTarget"><span class="hs-identifier hs-var">GPU.getActiveTarget</span></a></span><span>
</span><span id="line-49"></span><span>
</span><span id="line-50"></span><span class="annot"><a href="SDL.GPU.Simple.ContextControls.html#setActiveTarget"><span class="hs-identifier hs-type">setActiveTarget</span></a></span><span> </span><span class="hs-glyph">::</span><span> </span><span class="hs-keyword">forall</span><span> </span><span id="local-6989586621679189917"><span class="annot"><a href="#local-6989586621679189917"><span class="hs-identifier hs-type">m</span></a></span></span><span class="hs-operator">.</span><span> </span><span class="annot"><span class="hs-identifier hs-type">MonadIO</span></span><span> </span><span class="annot"><a href="#local-6989586621679189917"><span class="hs-identifier hs-type">m</span></a></span><span> </span><span class="hs-glyph">=&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Ptr</span></span><span> </span><span class="annot"><a href="SDL.GPU.C.Types.html#Target"><span class="hs-identifier hs-type">GPU.Target</span></a></span><span> </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="#local-6989586621679189917"><span class="hs-identifier hs-type">m</span></a></span><span> </span><span class="annot"><span class="hs-identifier hs-type">Prelude.Bool</span></span><span>
</span><span id="line-51"></span><span id="setActiveTarget"><span class="annot"><span class="annottext">setActiveTarget :: forall (m :: * -&gt; *). MonadIO m =&gt; Ptr Target -&gt; m Bool
</span><a href="SDL.GPU.Simple.ContextControls.html#setActiveTarget"><span class="hs-identifier hs-var hs-var">setActiveTarget</span></a></span></span><span> </span><span id="local-6989586621679189818"><span class="annot"><span class="annottext">Ptr Target
</span><a href="#local-6989586621679189818"><span class="hs-identifier hs-var">t</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">forall (f :: * -&gt; *) a b. Functor f =&gt; (a -&gt; b) -&gt; f a -&gt; f b
</span><span class="hs-identifier hs-var">fmap</span></span><span> </span><span class="annot"><span class="annottext">Bool -&gt; Bool
</span><a href="SDL.GPU.C.Bool.html#isTrue"><span class="hs-identifier hs-var">GPU.isTrue</span></a></span><span> </span><span class="annot"><span class="annottext">forall (f :: * -&gt; *) a b. Functor f =&gt; (a -&gt; b) -&gt; f a -&gt; f b
</span><span class="hs-operator hs-var">&lt;$&gt;</span></span><span> </span><span class="annot"><span class="annottext">forall (m :: * -&gt; *) a. MonadIO m =&gt; IO a -&gt; m a
</span><span class="hs-identifier hs-var">liftIO</span></span><span> </span><span class="annot"><span class="annottext">forall a b. (a -&gt; b) -&gt; a -&gt; b
</span><span class="hs-operator hs-var">$</span></span><span> </span><span class="annot"><span class="annottext">Ptr Target -&gt; IO Bool
</span><a href="SDL.GPU.C.ContextControls.html#setActiveTarget"><span class="hs-identifier hs-var">GPU.setActiveTarget</span></a></span><span> </span><span class="annot"><span class="annottext">Ptr Target
</span><a href="#local-6989586621679189818"><span class="hs-identifier hs-var">t</span></a></span><span>
</span><span id="line-52"></span><span>
</span><span id="line-53"></span><span class="annot"><a href="SDL.GPU.Simple.ContextControls.html#setShapeBlending"><span class="hs-identifier hs-type">setShapeBlending</span></a></span><span> </span><span class="hs-glyph">::</span><span> </span><span class="hs-keyword">forall</span><span> </span><span id="local-6989586621679189911"><span class="annot"><a href="#local-6989586621679189911"><span class="hs-identifier hs-type">m</span></a></span></span><span class="hs-operator">.</span><span> </span><span class="annot"><span class="hs-identifier hs-type">MonadIO</span></span><span> </span><span class="annot"><a href="#local-6989586621679189911"><span class="hs-identifier hs-type">m</span></a></span><span> </span><span class="hs-glyph">=&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Prelude.Bool</span></span><span> </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="#local-6989586621679189911"><span class="hs-identifier hs-type">m</span></a></span><span> </span><span class="hs-special">(</span><span class="hs-special">)</span><span>
</span><span id="line-54"></span><span id="setShapeBlending"><span class="annot"><span class="annottext">setShapeBlending :: forall (m :: * -&gt; *). MonadIO m =&gt; Bool -&gt; m ()
</span><a href="SDL.GPU.Simple.ContextControls.html#setShapeBlending"><span class="hs-identifier hs-var hs-var">setShapeBlending</span></a></span></span><span> </span><span id="local-6989586621679189812"><span class="annot"><span class="annottext">Bool
</span><a href="#local-6989586621679189812"><span class="hs-identifier hs-var">b</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">forall (m :: * -&gt; *) a. MonadIO m =&gt; IO a -&gt; m a
</span><span class="hs-identifier hs-var">liftIO</span></span><span> </span><span class="annot"><span class="annottext">forall a b. (a -&gt; b) -&gt; a -&gt; b
</span><span class="hs-operator hs-var">$</span></span><span> </span><span class="annot"><span class="annottext">Bool -&gt; IO ()
</span><a href="SDL.GPU.C.ContextControls.html#setShapeBlending"><span class="hs-identifier hs-var">GPU.setShapeBlending</span></a></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="annottext">Bool -&gt; Bool
</span><a href="SDL.GPU.C.Bool.html#bool"><span class="hs-identifier hs-var">GPU.bool</span></a></span><span> </span><span class="annot"><span class="annottext">Bool
</span><a href="#local-6989586621679189812"><span class="hs-identifier hs-var">b</span></a></span><span class="hs-special">)</span><span>
</span><span id="line-55"></span><span>
</span><span id="line-56"></span><span class="annot"><a href="SDL.GPU.Simple.ContextControls.html#getBlendModeFromPreset"><span class="hs-identifier hs-type">getBlendModeFromPreset</span></a></span><span>
</span><span id="line-57"></span><span>  </span><span class="hs-glyph">::</span><span> </span><span class="hs-keyword">forall</span><span> </span><span id="local-6989586621679189909"><span class="annot"><a href="#local-6989586621679189909"><span class="hs-identifier hs-type">m</span></a></span></span><span>
</span><span id="line-58"></span><span>   </span><span class="hs-operator">.</span><span> </span><span class="annot"><span class="hs-identifier hs-type">MonadIO</span></span><span> </span><span class="annot"><a href="#local-6989586621679189909"><span class="hs-identifier hs-type">m</span></a></span><span>
</span><span id="line-59"></span><span>  </span><span class="hs-glyph">=&gt;</span><span> </span><span class="annot"><a href="SDL.GPU.C.Types.html#BlendPresetEnum"><span class="hs-identifier hs-type">GPU.BlendPresetEnum</span></a></span><span>
</span><span id="line-60"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="#local-6989586621679189909"><span class="hs-identifier hs-type">m</span></a></span><span> </span><span class="hs-special">(</span><span class="annot"><a href="SDL.GPU.C.Types.html#BlendMode"><span class="hs-identifier hs-type">GPU.BlendMode</span></a></span><span class="hs-special">)</span><span>
</span><span id="line-61"></span><span id="getBlendModeFromPreset"><span class="annot"><span class="annottext">getBlendModeFromPreset :: forall (m :: * -&gt; *). MonadIO m =&gt; BlendPresetEnum -&gt; m BlendMode
</span><a href="SDL.GPU.Simple.ContextControls.html#getBlendModeFromPreset"><span class="hs-identifier hs-var hs-var">getBlendModeFromPreset</span></a></span></span><span> </span><span id="local-6989586621679189802"><span class="annot"><span class="annottext">BlendPresetEnum
</span><a href="#local-6989586621679189802"><span class="hs-identifier hs-var">preset</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">forall (m :: * -&gt; *) a. MonadIO m =&gt; IO a -&gt; m a
</span><span class="hs-identifier hs-var">liftIO</span></span><span> </span><span class="annot"><span class="annottext">forall a b. (a -&gt; b) -&gt; a -&gt; b
</span><span class="hs-operator hs-var">$</span></span><span> </span><span class="annot"><span class="annottext">forall a b. Storable a =&gt; (Ptr a -&gt; IO b) -&gt; IO b
</span><span class="hs-identifier hs-var">alloca</span></span><span> </span><span class="annot"><span class="annottext">forall a b. (a -&gt; b) -&gt; a -&gt; b
</span><span class="hs-operator hs-var">$</span></span><span> </span><span class="hs-glyph">\</span><span id="local-6989586621679189800"><span class="annot"><span class="annottext">Ptr BlendMode
</span><a href="#local-6989586621679189800"><span class="hs-identifier hs-var">pbm</span></a></span></span><span> </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><span class="annottext">Ptr BlendMode -&gt; BlendPresetEnum -&gt; IO ()
</span><a href="SDL.GPU.C.ContextControls.html#getBlendModeFromPreset"><span class="hs-identifier hs-var">GPU.getBlendModeFromPreset</span></a></span><span> </span><span class="annot"><span class="annottext">Ptr BlendMode
</span><a href="#local-6989586621679189800"><span class="hs-identifier hs-var">pbm</span></a></span><span> </span><span class="annot"><span class="annottext">BlendPresetEnum
</span><a href="#local-6989586621679189802"><span class="hs-identifier hs-var">preset</span></a></span><span> </span><span class="annot"><span class="annottext">forall (m :: * -&gt; *) a b. Monad m =&gt; m a -&gt; m b -&gt; m b
</span><span class="hs-operator hs-var">&gt;&gt;</span></span><span> </span><span class="annot"><span class="annottext">forall a. Storable a =&gt; Ptr a -&gt; IO a
</span><span class="hs-identifier hs-var">peek</span></span><span> </span><span class="annot"><span class="annottext">Ptr BlendMode
</span><a href="#local-6989586621679189800"><span class="hs-identifier hs-var">pbm</span></a></span><span>
</span><span id="line-62"></span><span>
</span><span id="line-63"></span><span class="annot"><a href="SDL.GPU.Simple.ContextControls.html#setShapeBlendFunction"><span class="hs-identifier hs-type">setShapeBlendFunction</span></a></span><span>
</span><span id="line-64"></span><span>  </span><span class="hs-glyph">::</span><span> </span><span class="hs-keyword">forall</span><span> </span><span id="local-6989586621679189899"><span class="annot"><a href="#local-6989586621679189899"><span class="hs-identifier hs-type">m</span></a></span></span><span>
</span><span id="line-65"></span><span>   </span><span class="hs-operator">.</span><span> </span><span class="annot"><span class="hs-identifier hs-type">MonadIO</span></span><span> </span><span class="annot"><a href="#local-6989586621679189899"><span class="hs-identifier hs-type">m</span></a></span><span>
</span><span id="line-66"></span><span>  </span><span class="hs-glyph">=&gt;</span><span> </span><span class="annot"><a href="SDL.GPU.C.Types.html#BlendFuncEnum"><span class="hs-identifier hs-type">GPU.BlendFuncEnum</span></a></span><span> </span><span class="hs-comment">-- ^ source_color</span><span>
</span><span id="line-67"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="SDL.GPU.C.Types.html#BlendFuncEnum"><span class="hs-identifier hs-type">GPU.BlendFuncEnum</span></a></span><span> </span><span class="hs-comment">-- ^ dest_color</span><span>
</span><span id="line-68"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="SDL.GPU.C.Types.html#BlendFuncEnum"><span class="hs-identifier hs-type">GPU.BlendFuncEnum</span></a></span><span> </span><span class="hs-comment">-- ^ source_alpha</span><span>
</span><span id="line-69"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="SDL.GPU.C.Types.html#BlendFuncEnum"><span class="hs-identifier hs-type">GPU.BlendFuncEnum</span></a></span><span> </span><span class="hs-comment">-- ^ dest_alpha</span><span>
</span><span id="line-70"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="#local-6989586621679189899"><span class="hs-identifier hs-type">m</span></a></span><span> </span><span class="hs-special">(</span><span class="hs-special">)</span><span>
</span><span id="line-71"></span><span id="setShapeBlendFunction"><span class="annot"><span class="annottext">setShapeBlendFunction :: forall (m :: * -&gt; *).
MonadIO m =&gt;
BlendFuncEnum
-&gt; BlendFuncEnum -&gt; BlendFuncEnum -&gt; BlendFuncEnum -&gt; m ()
</span><a href="SDL.GPU.Simple.ContextControls.html#setShapeBlendFunction"><span class="hs-identifier hs-var hs-var">setShapeBlendFunction</span></a></span></span><span> </span><span id="local-6989586621679189794"><span class="annot"><span class="annottext">BlendFuncEnum
</span><a href="#local-6989586621679189794"><span class="hs-identifier hs-var">f1</span></a></span></span><span> </span><span id="local-6989586621679189793"><span class="annot"><span class="annottext">BlendFuncEnum
</span><a href="#local-6989586621679189793"><span class="hs-identifier hs-var">f2</span></a></span></span><span> </span><span id="local-6989586621679189792"><span class="annot"><span class="annottext">BlendFuncEnum
</span><a href="#local-6989586621679189792"><span class="hs-identifier hs-var">f3</span></a></span></span><span> </span><span id="local-6989586621679189791"><span class="annot"><span class="annottext">BlendFuncEnum
</span><a href="#local-6989586621679189791"><span class="hs-identifier hs-var">f4</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">forall (m :: * -&gt; *) a. MonadIO m =&gt; IO a -&gt; m a
</span><span class="hs-identifier hs-var">liftIO</span></span><span> </span><span class="annot"><span class="annottext">forall a b. (a -&gt; b) -&gt; a -&gt; b
</span><span class="hs-operator hs-var">$</span></span><span> </span><span class="annot"><span class="annottext">BlendFuncEnum
-&gt; BlendFuncEnum -&gt; BlendFuncEnum -&gt; BlendFuncEnum -&gt; IO ()
</span><a href="SDL.GPU.C.ContextControls.html#setShapeBlendFunction"><span class="hs-identifier hs-var">GPU.setShapeBlendFunction</span></a></span><span> </span><span class="annot"><span class="annottext">BlendFuncEnum
</span><a href="#local-6989586621679189794"><span class="hs-identifier hs-var">f1</span></a></span><span> </span><span class="annot"><span class="annottext">BlendFuncEnum
</span><a href="#local-6989586621679189793"><span class="hs-identifier hs-var">f2</span></a></span><span> </span><span class="annot"><span class="annottext">BlendFuncEnum
</span><a href="#local-6989586621679189792"><span class="hs-identifier hs-var">f3</span></a></span><span> </span><span class="annot"><span class="annottext">BlendFuncEnum
</span><a href="#local-6989586621679189791"><span class="hs-identifier hs-var">f4</span></a></span><span>
</span><span id="line-72"></span><span>
</span><span id="line-73"></span><span class="annot"><a href="SDL.GPU.Simple.ContextControls.html#setShapeBlendEquation"><span class="hs-identifier hs-type">setShapeBlendEquation</span></a></span><span>
</span><span id="line-74"></span><span>  </span><span class="hs-glyph">::</span><span> </span><span class="hs-keyword">forall</span><span> </span><span id="local-6989586621679189896"><span class="annot"><a href="#local-6989586621679189896"><span class="hs-identifier hs-type">m</span></a></span></span><span>
</span><span id="line-75"></span><span>   </span><span class="hs-operator">.</span><span> </span><span class="annot"><span class="hs-identifier hs-type">MonadIO</span></span><span> </span><span class="annot"><a href="#local-6989586621679189896"><span class="hs-identifier hs-type">m</span></a></span><span>
</span><span id="line-76"></span><span>  </span><span class="hs-glyph">=&gt;</span><span> </span><span class="annot"><a href="SDL.GPU.C.Types.html#BlendEqEnum"><span class="hs-identifier hs-type">GPU.BlendEqEnum</span></a></span><span> </span><span class="hs-comment">-- ^ color_equation</span><span>
</span><span id="line-77"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="SDL.GPU.C.Types.html#BlendEqEnum"><span class="hs-identifier hs-type">GPU.BlendEqEnum</span></a></span><span> </span><span class="hs-comment">-- ^ alpha_equation</span><span>
</span><span id="line-78"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="#local-6989586621679189896"><span class="hs-identifier hs-type">m</span></a></span><span> </span><span class="hs-special">(</span><span class="hs-special">)</span><span>
</span><span id="line-79"></span><span id="setShapeBlendEquation"><span class="annot"><span class="annottext">setShapeBlendEquation :: forall (m :: * -&gt; *).
MonadIO m =&gt;
BlendEqEnum -&gt; BlendEqEnum -&gt; m ()
</span><a href="SDL.GPU.Simple.ContextControls.html#setShapeBlendEquation"><span class="hs-identifier hs-var hs-var">setShapeBlendEquation</span></a></span></span><span> </span><span id="local-6989586621679189786"><span class="annot"><span class="annottext">BlendEqEnum
</span><a href="#local-6989586621679189786"><span class="hs-identifier hs-var">e1</span></a></span></span><span> </span><span id="local-6989586621679189785"><span class="annot"><span class="annottext">BlendEqEnum
</span><a href="#local-6989586621679189785"><span class="hs-identifier hs-var">e2</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">forall (m :: * -&gt; *) a. MonadIO m =&gt; IO a -&gt; m a
</span><span class="hs-identifier hs-var">liftIO</span></span><span> </span><span class="annot"><span class="annottext">forall a b. (a -&gt; b) -&gt; a -&gt; b
</span><span class="hs-operator hs-var">$</span></span><span> </span><span class="annot"><span class="annottext">BlendEqEnum -&gt; BlendEqEnum -&gt; IO ()
</span><a href="SDL.GPU.C.ContextControls.html#setShapeBlendEquation"><span class="hs-identifier hs-var">GPU.setShapeBlendEquation</span></a></span><span> </span><span class="annot"><span class="annottext">BlendEqEnum
</span><a href="#local-6989586621679189786"><span class="hs-identifier hs-var">e1</span></a></span><span> </span><span class="annot"><span class="annottext">BlendEqEnum
</span><a href="#local-6989586621679189785"><span class="hs-identifier hs-var">e2</span></a></span><span>
</span><span id="line-80"></span><span>
</span><span id="line-81"></span><span class="annot"><a href="SDL.GPU.Simple.ContextControls.html#setShapeBlendMode"><span class="hs-identifier hs-type">setShapeBlendMode</span></a></span><span>
</span><span id="line-82"></span><span>  </span><span class="hs-glyph">::</span><span> </span><span class="hs-keyword">forall</span><span> </span><span id="local-6989586621679189893"><span class="annot"><a href="#local-6989586621679189893"><span class="hs-identifier hs-type">m</span></a></span></span><span>
</span><span id="line-83"></span><span>   </span><span class="hs-operator">.</span><span> </span><span class="annot"><span class="hs-identifier hs-type">MonadIO</span></span><span> </span><span class="annot"><a href="#local-6989586621679189893"><span class="hs-identifier hs-type">m</span></a></span><span>
</span><span id="line-84"></span><span>  </span><span class="hs-glyph">=&gt;</span><span> </span><span class="annot"><a href="SDL.GPU.C.Types.html#BlendPresetEnum"><span class="hs-identifier hs-type">GPU.BlendPresetEnum</span></a></span><span>
</span><span id="line-85"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="#local-6989586621679189893"><span class="hs-identifier hs-type">m</span></a></span><span> </span><span class="hs-special">(</span><span class="hs-special">)</span><span>
</span><span id="line-86"></span><span id="setShapeBlendMode"><span class="annot"><span class="annottext">setShapeBlendMode :: forall (m :: * -&gt; *). MonadIO m =&gt; BlendPresetEnum -&gt; m ()
</span><a href="SDL.GPU.Simple.ContextControls.html#setShapeBlendMode"><span class="hs-identifier hs-var hs-var">setShapeBlendMode</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">forall (m :: * -&gt; *) a. MonadIO m =&gt; IO a -&gt; m a
</span><span class="hs-identifier hs-var">liftIO</span></span><span> </span><span class="annot"><span class="annottext">forall b c a. (b -&gt; c) -&gt; (a -&gt; b) -&gt; a -&gt; c
</span><span class="hs-operator hs-var">.</span></span><span> </span><span class="annot"><span class="annottext">BlendPresetEnum -&gt; IO ()
</span><a href="SDL.GPU.C.ContextControls.html#setShapeBlendMode"><span class="hs-identifier hs-var">GPU.setShapeBlendMode</span></a></span><span>
</span><span id="line-87"></span><span>
</span><span id="line-88"></span><span class="annot"><a href="SDL.GPU.Simple.ContextControls.html#setLineThickness"><span class="hs-identifier hs-type">setLineThickness</span></a></span><span>
</span><span id="line-89"></span><span>  </span><span class="hs-glyph">::</span><span> </span><span class="hs-keyword">forall</span><span> </span><span id="local-6989586621679189891"><span class="annot"><a href="#local-6989586621679189891"><span class="hs-identifier hs-type">m</span></a></span></span><span>
</span><span id="line-90"></span><span>   </span><span class="hs-operator">.</span><span> </span><span class="annot"><span class="hs-identifier hs-type">MonadIO</span></span><span> </span><span class="annot"><a href="#local-6989586621679189891"><span class="hs-identifier hs-type">m</span></a></span><span>
</span><span id="line-91"></span><span>  </span><span class="hs-glyph">=&gt;</span><span> </span><span class="annot"><a href="SDL.GPU.C.NumericTypes.html#Float"><span class="hs-identifier hs-type">GPU.Float</span></a></span><span> </span><span class="hs-comment">-- ^ thickness</span><span>
</span><span id="line-92"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="#local-6989586621679189891"><span class="hs-identifier hs-type">m</span></a></span><span> </span><span class="annot"><a href="SDL.GPU.C.NumericTypes.html#Float"><span class="hs-identifier hs-type">GPU.Float</span></a></span><span> </span><span class="hs-comment">-- ^ the old thickness value</span><span>
</span><span id="line-93"></span><span id="setLineThickness"><span class="annot"><span class="annottext">setLineThickness :: forall (m :: * -&gt; *). MonadIO m =&gt; Float -&gt; m Float
</span><a href="SDL.GPU.Simple.ContextControls.html#setLineThickness"><span class="hs-identifier hs-var hs-var">setLineThickness</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">forall (m :: * -&gt; *) a. MonadIO m =&gt; IO a -&gt; m a
</span><span class="hs-identifier hs-var">liftIO</span></span><span> </span><span class="annot"><span class="annottext">forall b c a. (b -&gt; c) -&gt; (a -&gt; b) -&gt; a -&gt; c
</span><span class="hs-operator hs-var">.</span></span><span> </span><span class="annot"><span class="annottext">Float -&gt; IO Float
</span><a href="SDL.GPU.C.ContextControls.html#setLineThickness"><span class="hs-identifier hs-var">GPU.setLineThickness</span></a></span><span>
</span><span id="line-94"></span><span>
</span><span id="line-95"></span><span class="annot"><a href="SDL.GPU.Simple.ContextControls.html#getLineThickness"><span class="hs-identifier hs-type">getLineThickness</span></a></span><span>
</span><span id="line-96"></span><span>  </span><span class="hs-glyph">::</span><span> </span><span class="hs-keyword">forall</span><span> </span><span id="local-6989586621679189888"><span class="annot"><a href="#local-6989586621679189888"><span class="hs-identifier hs-type">m</span></a></span></span><span>
</span><span id="line-97"></span><span>   </span><span class="hs-operator">.</span><span> </span><span class="annot"><span class="hs-identifier hs-type">MonadIO</span></span><span> </span><span class="annot"><a href="#local-6989586621679189888"><span class="hs-identifier hs-type">m</span></a></span><span>
</span><span id="line-98"></span><span>  </span><span class="hs-glyph">=&gt;</span><span> </span><span class="annot"><a href="#local-6989586621679189888"><span class="hs-identifier hs-type">m</span></a></span><span> </span><span class="annot"><a href="SDL.GPU.C.NumericTypes.html#Float"><span class="hs-identifier hs-type">GPU.Float</span></a></span><span>
</span><span id="line-99"></span><span id="getLineThickness"><span class="annot"><span class="annottext">getLineThickness :: forall (m :: * -&gt; *). MonadIO m =&gt; m Float
</span><a href="SDL.GPU.Simple.ContextControls.html#getLineThickness"><span class="hs-identifier hs-var hs-var">getLineThickness</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">forall (m :: * -&gt; *) a. MonadIO m =&gt; IO a -&gt; m a
</span><span class="hs-identifier hs-var">liftIO</span></span><span> </span><span class="annot"><span class="annottext">IO Float
</span><a href="SDL.GPU.C.ContextControls.html#getLineThickness"><span class="hs-identifier hs-var">GPU.getLineThickness</span></a></span><span>
</span><span id="line-100"></span></pre></body></html>